package main

import (
	"fmt"
	_ "fmt"
	"fts/config"
	"fts/websocket"
	_ "github.com/ipfs/go-ipfs-api"
	"io/ioutil"
	"log"
	"net/http"
	"os"
	_ "os"
	_ "strings"
)

//func copyAndCapture(w io.Writer, r io.Reader) ([]byte, error) {
//	var out []byte
//	buf := make([]byte, 1024, 1024)
//	for {
//		n, err := r.Read(buf[:])
//		if n > 0 {
//			d := buf[:n]
//			out = append(out, d...)
//			os.Stdout.Write(d)
//		}
//		if err != nil {
//			// Read returns io.EOF at the end of file, which is not an error for us
//			if err == io.EOF {
//				err = nil
//			}
//			return out, err
//		}
//	}
//	// never reached
//	panic(true)
//	return nil, nil
//}


func main() {

	//cmd := exec.Command("cmd","/C", "ipfs add C:\\Users\\yuan_rh\\Downloads\\QmRzN7uW6HCVAkGMXNWv3rC9dqPJijvEgvtW6DKsQQE8Js")
	//var stdout, stderr []byte
	//var errStdout, errStderr error
	//stdoutIn, _ := cmd.StdoutPipe()
	//stderrIn, _ := cmd.StderrPipe()
	//cmd.Start()
	//go func() {
	//	stdout, errStdout = copyAndCapture(os.Stdout, stdoutIn)
	//}()
	//go func() {
	//	stderr, errStderr = copyAndCapture(os.Stderr, stderrIn)
	//}()
	//
	//err := cmd.Wait()
	//if err != nil {
	//	log.Fatalf("cmd.Run() failed with %s\n", err)
	//}
	//if errStdout != nil || errStderr != nil {
	//	log.Fatalf("failed to capture stdout or stderr\n")
	//}
	//outStr, errStr := string(stdout), string(stderr)
	//fmt.Printf("\nout:\n%s\nerr:\n%s\n", outStr, errStr)
	config.InitConfig()
	//handle.InitLocalWorkSpace("324523676458291200","11.4")

	//http://localhost:7777/ws
	http.HandleFunc("/upload", websocket.UploadHandler)
	http.HandleFunc("/subscriptionFileChange", websocket.SubscriptionFileChangeHandler)
	http.HandleFunc("/download", websocket.DownloadHandler)
	http.HandleFunc("/init", websocket.InitLocalWorkSpaceHandler)

	//服务端启动
	fmt.Println("启动服务，监听端口7777")
	http.ListenAndServe("0.0.0.0:7777", nil)



}

// 递归扫描目录
func ScanDirs(dirName string) []string {
	files, err := ioutil.ReadDir(dirName)
	if err != nil {
		log.Println(err)
	}
	var fileList []string
	for _, file := range files {
		fmt.Println(file.Name()+" "+file.ModTime().String())
		fileList = append(fileList, dirName + string(os.PathSeparator) + file.Name())
		if file.IsDir() {
			fileList = append(fileList, ScanDirs(dirName + string(os.PathSeparator) + file.Name())...)
		}
	}
	return fileList
}